#include <math.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/fail.h>
#include <caml/alloc.h>
#include "config.h"
#ifndef HAVE_FMA
double fma(double,double,double) { failwith("fma unimplemented"); }
#endif
value stew_fma(value a0,value a1,value a2) {
#ifdef HAVE_FMA
return copy_double(fma(Double_val(a0),Double_val(a1),Double_val(a2)));
#else
failwith("fma unimplemented");
#endif
}
#ifndef HAVE_FDIM
double fdim(double,double) { failwith("fdim unimplemented"); }
#endif
value stew_fdim(value a0,value a1) {
#ifdef HAVE_FDIM
return copy_double(fdim(Double_val(a0),Double_val(a1)));
#else
failwith("fdim unimplemented");
#endif
}
#ifndef HAVE_NEXTAFTER
double nextafter(double,double) { failwith("nextafter unimplemented"); }
#endif
value stew_nextafter(value a0,value a1) {
#ifdef HAVE_NEXTAFTER
return copy_double(nextafter(Double_val(a0),Double_val(a1)));
#else
failwith("nextafter unimplemented");
#endif
}
#ifndef HAVE_REMAINDER
double remainder(double,double) { failwith("remainder unimplemented"); }
#endif
value stew_remainder(value a0,value a1) {
#ifdef HAVE_REMAINDER
return copy_double(remainder(Double_val(a0),Double_val(a1)));
#else
failwith("remainder unimplemented");
#endif
}
#ifndef HAVE_TRUNC
double trunc(double) { failwith("trunc unimplemented"); }
#endif
value stew_trunc(value a0) {
#ifdef HAVE_TRUNC
return copy_double(trunc(Double_val(a0)));
#else
failwith("trunc unimplemented");
#endif
}
#ifndef HAVE_ROUND
double round(double) { failwith("round unimplemented"); }
#endif
value stew_round(value a0) {
#ifdef HAVE_ROUND
return copy_double(round(Double_val(a0)));
#else
failwith("round unimplemented");
#endif
}
#ifndef HAVE_NEARBYINT
double nearbyint(double) { failwith("nearbyint unimplemented"); }
#endif
value stew_nearbyint(value a0) {
#ifdef HAVE_NEARBYINT
return copy_double(nearbyint(Double_val(a0)));
#else
failwith("nearbyint unimplemented");
#endif
}
#ifndef HAVE_TGAMMA
double tgamma(double) { failwith("tgamma unimplemented"); }
#endif
value stew_tgamma(value a0) {
#ifdef HAVE_TGAMMA
return copy_double(tgamma(Double_val(a0)));
#else
failwith("tgamma unimplemented");
#endif
}
#ifndef HAVE_LGAMMA
double lgamma(double) { failwith("lgamma unimplemented"); }
#endif
value stew_lgamma(value a0) {
#ifdef HAVE_LGAMMA
return copy_double(lgamma(Double_val(a0)));
#else
failwith("lgamma unimplemented");
#endif
}
#ifndef HAVE_ERFC
double erfc(double) { failwith("erfc unimplemented"); }
#endif
value stew_erfc(value a0) {
#ifdef HAVE_ERFC
return copy_double(erfc(Double_val(a0)));
#else
failwith("erfc unimplemented");
#endif
}
#ifndef HAVE_ERF
double erf(double) { failwith("erf unimplemented"); }
#endif
value stew_erf(value a0) {
#ifdef HAVE_ERF
return copy_double(erf(Double_val(a0)));
#else
failwith("erf unimplemented");
#endif
}
#ifndef HAVE_HYPOT
double hypot(double,double) { failwith("hypot unimplemented"); }
#endif
value stew_hypot(value a0,value a1) {
#ifdef HAVE_HYPOT
return copy_double(hypot(Double_val(a0),Double_val(a1)));
#else
failwith("hypot unimplemented");
#endif
}
#ifndef HAVE_CBRT
double cbrt(double) { failwith("cbrt unimplemented"); }
#endif
value stew_cbrt(value a0) {
#ifdef HAVE_CBRT
return copy_double(cbrt(Double_val(a0)));
#else
failwith("cbrt unimplemented");
#endif
}
#ifndef HAVE_SCALBN
double scalbn(double,int) { failwith("scalbn unimplemented"); }
#endif
value stew_scalbn(value a0,value a1) {
#ifdef HAVE_SCALBN
return copy_double(scalbn(Double_val(a0),Long_val(a1)));
#else
failwith("scalbn unimplemented");
#endif
}
#ifndef HAVE_LOGB
double logb(double) { failwith("logb unimplemented"); }
#endif
value stew_logb(value a0) {
#ifdef HAVE_LOGB
return copy_double(logb(Double_val(a0)));
#else
failwith("logb unimplemented");
#endif
}
#ifndef HAVE_LOG2
double log2(double) { failwith("log2 unimplemented"); }
#endif
value stew_log2(value a0) {
#ifdef HAVE_LOG2
return copy_double(log2(Double_val(a0)));
#else
failwith("log2 unimplemented");
#endif
}
#ifndef HAVE_LOG1P
double log1p(double) { failwith("log1p unimplemented"); }
#endif
value stew_log1p(value a0) {
#ifdef HAVE_LOG1P
return copy_double(log1p(Double_val(a0)));
#else
failwith("log1p unimplemented");
#endif
}
#ifndef HAVE_ILOGB
int ilogb(double) { failwith("ilogb unimplemented"); }
#endif
value stew_ilogb(value a0) {
#ifdef HAVE_ILOGB
return Val_long(ilogb(Double_val(a0)));
#else
failwith("ilogb unimplemented");
#endif
}
#ifndef HAVE_EXPM1
double expm1(double) { failwith("expm1 unimplemented"); }
#endif
value stew_expm1(value a0) {
#ifdef HAVE_EXPM1
return copy_double(expm1(Double_val(a0)));
#else
failwith("expm1 unimplemented");
#endif
}
#ifndef HAVE_EXP2
double exp2(double) { failwith("exp2 unimplemented"); }
#endif
value stew_exp2(value a0) {
#ifdef HAVE_EXP2
return copy_double(exp2(Double_val(a0)));
#else
failwith("exp2 unimplemented");
#endif
}
#ifndef HAVE_ATANH
double atanh(double) { failwith("atanh unimplemented"); }
#endif
value stew_atanh(value a0) {
#ifdef HAVE_ATANH
return copy_double(atanh(Double_val(a0)));
#else
failwith("atanh unimplemented");
#endif
}
#ifndef HAVE_ASINH
double asinh(double) { failwith("asinh unimplemented"); }
#endif
value stew_asinh(value a0) {
#ifdef HAVE_ASINH
return copy_double(asinh(Double_val(a0)));
#else
failwith("asinh unimplemented");
#endif
}
#ifndef HAVE_ACOSH
double acosh(double) { failwith("acosh unimplemented"); }
#endif
value stew_acosh(value a0) {
#ifdef HAVE_ACOSH
return copy_double(acosh(Double_val(a0)));
#else
failwith("acosh unimplemented");
#endif
}
